/*---------------------------------------------------------------------------
  Project:  ImageDb
  File:     ImageIOSearch.h
  
  ʐ^̗񋓌񋟂܂B
  ---------------------------------------------------------------------------*/
#ifndef IMAGE_IO_SEARCH_H_
#define IMAGE_IO_SEARCH_H_

#include <nn/fnd.h>
#include "ImageIOTypes.h"


namespace imgdb {
    namespace search {


/*!----------------------------------------------------------------------
  @brief    ʐ^@\̏s
  @details
  ʐ^̗񋓌𗘗pOɂPxĂяoKv܂B<BR>
  imgdb::Initialize()ɌĂяoKv܂B<BR>
  {֐Ăяo Finalize() Ă΂܂ 24KB ̃܂B
  -----------------------------------------------------------------------*/
void Initialize();

/*!----------------------------------------------------------------------
  @brief    ʐ^@\I
  @details
  imgdb::Finalize()OɌĂяoĂB
  -----------------------------------------------------------------------*/
void Finalize();


/*!----------------------------------------------------------------------
  @brief    ImageDb ɊǗĂʐ^
  @details
  ImageDb ɊǗĂʐ^Ǎʂɕۑ܂B<BR>
  ʂ GetTitleUniqueId()  GetPath() ȂǂɃCfbNXw
  Ď擾ł܂B<BR>
  ʂ͎BeƂɏŕł܂iCfbNXƌ
  ʐ^A傫ƐVʐ^jB<BR>
  PCSDJ[hɒڎʐ^ǉ폜ꂽꍇȂǂɁA̎ʐ^Ǘ
  邽߂ɂ́ACollectPicture()ĂяoKv܂B<BR>  

  SDJ[h݂ȂA܂͔FłĂȂꍇ́Aʃ[Ƃ
  I܂B<BR>

  ŕۑĂ錟ʂ́Aȉ̃Cxg⑀ŖɂȂ܂B<BR>
  ȏԂ Get`() ĂяoƁAAT[g̔ԈԂ
  邽߁AĂяo͔ĂB<BR>
  ēx SearchPicture() ŌȂƂŗLȏԂɖ߂܂B<BR>
  ESDJ[hꂽƂ<BR>
  ESDJ[hꂽƂ<BR>
  EJpegSaver/MpSaverŎʐ^ۑƂ<BR>
  EDeletePicture()Ŏʐ^폜Ƃ<BR>
  ECollectPicture()ŊǗt@CXVƂ<BR>
  EHOMEj[߂ƂiHOMEj[JŎBeꂽ\邽߁j
  -----------------------------------------------------------------------*/
void SearchPicture();

/*!----------------------------------------------------------------------
  @brief    ʂ̎ʐ^擾
  @return   ʐ^
  @details
  Pʐ^Ȃꍇ̓[Ԃ܂B
  -----------------------------------------------------------------------*/
int GetResultNum();

/*!----------------------------------------------------------------------
  @brief    ^Cgj[NID擾
  @param[in]    nIndex  擾f[^̃CfbNX [0, GetResultNum())
  @return   ^Cgj[NID
  -----------------------------------------------------------------------*/
u32 GetTitleUniqueId(int nIndex);

/*!----------------------------------------------------------------------
  @brief    ʐ^̃pX擾
  @param[out]   pPath   pXi[obt@iksj
  @param[in]    nSize   pXi[obt@̃TCYiPʁj
  @param[in]    nIndex  擾f[^̃CfbNX [0, GetResultNum())
  @details
  pPathnSizec_nMaxPathSizeȏ̃obt@w肷Kv܂B
  obt@sĂꍇ̓AT[g܂B
  -----------------------------------------------------------------------*/
void GetPath(wchar_t* pPath, int nSize, int nIndex);

/*!----------------------------------------------------------------------
  @brief    ʐ^̎ނ擾
  @param[in]    nIndex  擾f[^̃CfbNX [0, GetResultNum())
  @return   ʐ^̎
  -----------------------------------------------------------------------*/
imgio::ImageKind GetImageKind(int nIndex);

/*!----------------------------------------------------------------------
  @brief    Be擾
  @param[in]    nIndex      擾f[^̃CfbNX [0, GetResultNum())
  @return   Be
  -----------------------------------------------------------------------*/
nn::fnd::DateTime GetDateTime(int nIndex);


    } // end of namespace search
} // end of namespace imgdb

#endif // IMAGE_ENUMERATOR_H_
